#!/usr/bin/perl
# Atomic Secured Linux 
# Copyright Atomicorp, 2015
# License: Commercial, unauthorized redistribution or duplication is prohibited
# ASL: Config file validator

$template="/var/asl/data/templates/config.template";
$target="/etc/asl/config";



# Open our template file
open (TEMPLATE, "$template");

# clean out comments/newlines from signature data
while( <TEMPLATE> ) {


  $line=$_;
  
  # If we're setting something new in the template, just spew this forth and ignore the old file
  print $line if not /.*@@.*/;



  # Compare template with existing file
  # if the line has @@, split into array
  if ($line =~ /.*@@.*/) {
    my @vars=split(/="/,$line);
    #print "DEBUG: @vars[0] @vars[1]"; 
    
    # load the target file
    open (TARGET, "$target");
    while ($t_line=<TARGET>) {
      #print "DEBUG: $t_line\n";
      
      #split each element into left and right
      my @t_vars=split(/="/,$t_line);

      # if the old file has the var set, we use that, otherwise use the default
      # test each line to see if its there
      if (@t_vars[0] eq @vars[0]) {
        # we've matched

        # Some minor fixes, if its not yes, or no, then wrap it in quotes
        if ( @t_vars[1] eq /yes|no/i) {
          $matched="@t_vars[0]=@t_vars[1]";
        } else {
          chomp @t_vars[1];
          @t_vars[1] =~ s/"//g;
          $matched="@t_vars[0]=\"@t_vars[1]\"\n";
          # Look at me hack!
	  $matched =~ s/ "/"/g;
        }
      }
      
    }


    # Done loading the file, If we've matched, print out the match, otherwise print out the default
    if ($matched ) {
      print "$matched";
    } else {
      $line =~ s/@@//g;
      # the default
      print "$line";
    }

    # clear matched, so we can go to the next one
    undef $matched;

  }

}

