SET autocommit=0;

CREATE TABLE IF NOT EXISTS aslw_stat_rule (id int PRIMARY KEY AUTO_INCREMENT,dt date NOT NULL DEFAULT '1000-01-01',rule_id int NOT NULL DEFAULT '0',level int NOT NULL DEFAULT '0',total int NOT NULL DEFAULT '0',UNIQUE INDEX dtr (dt,rule_id),INDEX lvl (level));
CREATE TABLE IF NOT EXISTS aslw_stat_ip (id int PRIMARY KEY AUTO_INCREMENT,dt date NOT NULL DEFAULT '1000-01-01',ip varchar(39) NOT NULL DEFAULT '',rule_id int NOT NULL DEFAULT '0',tld varchar(5) NOT NULL DEFAULT '',total int NOT NULL DEFAULT '0',UNIQUE INDEX dir (dt,ip,rule_id),INDEX r (rule_id),INDEX t(tld));
CREATE TABLE IF NOT EXISTS aslw_stat_geo (id int PRIMARY KEY AUTO_INCREMENT,dt date NOT NULL DEFAULT '1000-01-01',code varchar(5) NOT NULL DEFAULT '',rule_id int NOT NULL DEFAULT '0',total int NOT NULL DEFAULT '0',UNIQUE INDEX dcr (dt,code,rule_id),INDEX r (rule_id));
CREATE TABLE IF NOT EXISTS aslw_stat_dow_hod (id int PRIMARY KEY AUTO_INCREMENT,day_of_week int NOT NULL DEFAULT '0',hour_of_day int NOT NULL default '0', total int NOT NULL DEFAULT '0', UNIQUE INDEX dh (day_of_week,hour_of_day), INDEX (hour_of_day));
CREATE TABLE IF NOT EXISTS aslw_geo_range (id int PRIMARY KEY AUTO_INCREMENT,code varchar(5) NOT NULL DEFAULT '',ip_cidr varchar(19) NOT NULL DEFAULT '',ip_start int UNSIGNED NOT NULL DEFAULT '0',ip_end int UNSIGNED NOT NULL DEFAULT '0',UNIQUE INDEX cidr (ip_cidr),INDEX se (ip_start,ip_end));
CREATE TABLE IF NOT EXISTS aslw_saved_search (id int PRIMARY KEY AUTO_INCREMENT,title varchar(50) NOT NULL DEFAULT '',machine_name varchar(50) NOT NULL DEFAULT '',user_id int NOT NULL DEFAULT '0',data text,UNIQUE INDEX nu (user_id,title));
CREATE TABLE IF NOT EXISTS aslw_mtimes (table_name varchar(100) PRIMARY KEY NOT NULL DEFAULT '',mtime datetime NOT NULL DEFAULT '1000-01-01 00:00:00');
CREATE TABLE if NOT EXISTS aslw_archive_tmp LIKE alert;
CREATE TABLE if NOT EXISTS aslw_user (user_id int PRIMARY KEY NOT NULL AUTO_INCREMENT,username varchar(250) NOT NULL DEFAULT '',password varchar(250) NOT NULL DEFAULT '',email varchar(250) NOT NULL DEFAULT '',email_sms varchar(250) NOT NULL DEFAULT '',use_tfa tinyint NOT NULL DEFAULT '0',group_id int NOT NULL DEFAULT '0',is_admin tinyint NOT NULL DEFAULT '0',enabled tinyint NOT NULL DEFAULT '1',layout text,f_eula tinyint NOT NULL default '0',UNIQUE INDEX (username));
CREATE TABLE if NOT EXISTS aslw_user_group (id int PRIMARY KEY NOT NULL AUTO_INCREMENT,name varchar(250) NOT NULL DEFAULT '',salt varchar(20) NOT NULL DEFAULT '',privs text,UNIQUE INDEX (name));
CREATE TABLE IF NOT EXISTS aslw_user_settings (user_id int PRIMARY KEY NOT NULL DEFAULT '0',salt varchar(20) NOT NULL DEFAULT '',data text);
CREATE TABLE IF NOT EXISTS aslw_log (id int PRIMARY KEY NOT NULL AUTO_INCREMENT,user_id int NOT NULL DEFAULT '0',dt datetime NOT NULL DEFAULT '1000-01-01 00:00:00',status int NOT NULL DEFAULT '0',src_ip int NOT NULL DEFAULT '0',data text,INDEX uid (user_id));
CREATE TABLE IF NOT EXISTS aslw_blocklist (id int PRIMARY KEY NOT NULL AUTO_INCREMENT,rule_id	int NOT NULL DEFAULT '0',src_ip int UNSIGNED NOT NULL DEFAULT '0',alertid varchar(50) NOT NULL DEFAULT '',is_blocked tinyint NOT NULL DEFAULT '1',INDEX (src_ip),INDEX (alertid),INDEX (rule_id),INDEX (is_blocked));
CREATE TABLE IF NOT EXISTS aslw_domain_block (id int PRIMARY KEY NOT NULL auto_increment,domain varchar(250) NOT NULL DEFAULT '',reason text NULL,user_id int NOT NULL default '0',ts_list timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,UNIQUE INDEX d (domain));
CREATE TABLE IF NOT EXISTS pgui_waf_cat (cat_id int PRIMARY KEY NOT NULL auto_increment,name varchar(250) NOT NULL default '',parent_name varchar(250) NOT NULL default '',UNIQUE INDEX npn (name,parent_name)) CHARACTER SET latin1;
CREATE TABLE IF NOT EXISTS pgui_waf_cat_rule_map (map_id int PRIMARY KEY NOT NULL auto_increment,cat_id int NOT NULL default '0',rule_id int NOT NULL DEFAULT '0',UNIQUE INDEX cr (cat_id,rule_id));
CREATE TABLE IF NOT EXISTS pgui_waf_rules (rule_id int PRIMARY KEY NOT NULL default '0',description varchar(250) NOT NULL default '');
CREATE TABLE IF NOT EXISTS pgui_hids_cat (cat_id int PRIMARY KEY NOT NULL default '0',name varchar(250) NOT NULL default '',parent_name varchar(250) NOT NULL default '',UNIQUE INDEX npn (name,parent_name)) CHARACTER SET latin1;
CREATE TABLE IF NOT EXISTS pgui_bl_reason (id int PRIMARY KEY NOT NULL auto_increment,btype varchar(20) NOT NULL DEFAULT '',ip varchar(20) NOT NULL DEFAULT '',user_id int NOT NULL default '0',reason text NULL,ts_list timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,UNIQUE INDEX ipt (ip,btype));
CREATE TABLE IF NOT EXISTS pgui_rule_def (rule_id int PRIMARY KEY NOT NULL DEFAULT '0',waf_rule_id int NULL,email tinyint NULL,log tinyint NULL,ar tinyint NULL,level int NULL,UNIQUE INDEX rw (rule_id,waf_rule_id));

CREATE TABLE IF NOT EXISTS aslw_rules_build (p_id int PRIMARY KEY NOT NULL AUTO_INCREMENT,source_file varchar(255) NOT NULL DEFAULT '',type varchar(50) NOT NULL DEFAULT '',id varchar(250) NOT NULL DEFAULT '',data text);
CREATE TABLE IF NOT EXISTS aslw_rules (id int PRIMARY KEY NOT NULL AUTO_INCREMENT,rule_id int NOT NULL DEFAULT '0',type varchar(50) NOT NULL DEFAULT '0',level int NOT NULL DEFAULT '0',disabled tinyint NOT NULL DEFAULT '0',opt_ar tinyint NULL,opt_email tinyint NULL,opt_log tinyint NULL,description varchar(255) NOT NULL DEFAULT '',INDEX (rule_id),INDEX (description));

DROP TRIGGER IF EXISTS before_alert_insert;
DROP TRIGGER IF EXISTS after_alert_insert;
DROP TRIGGER IF EXISTS after_category_insert;
DROP TRIGGER IF EXISTS after_signature_insert;
DROP TRIGGER IF EXISTS after_signature_category_mapping_insert;
DROP TRIGGER IF EXISTS after_pgui_waf_cat_insert;
DROP TRIGGER IF EXISTS after_pgui_waf_cat_rule_map_insert;
DROP TRIGGER IF EXISTS after_pgui_waf_rules_insert;
DELIMITER @@
CREATE TRIGGER after_alert_insert AFTER INSERT ON alert FOR EACH ROW 
	BEGIN 
		INSERT INTO aslw_stat_rule (dt,rule_id,level,total) VALUES (now(),NEW.rule_id,NEW.level,1) ON DUPLICATE KEY UPDATE total=total+1; 
		INSERT INTO aslw_stat_ip (dt,ip,rule_id,tld,total) VALUES (now(),NEW.src_ip,NEW.rule_id,NEW.tld,1) ON DUPLICATE KEY UPDATE total=total+1; 
		INSERT INTO aslw_stat_geo (dt,code,rule_id,total) VALUES (now(),NEW.tld,NEW.rule_id,1) ON DUPLICATE KEY UPDATE total=total+1; 
		INSERT INTO aslw_stat_dow_hod (day_of_week,hour_of_day,total) VALUES (DAYOFWEEK(now()),HOUR(now()),1) ON DUPLICATE KEY UPDATE total=total+1; 
		REPLACE INTO aslw_mtimes (table_name,mtime) VALUES ('alert',NOW()); 
		INSERT IGNORE INTO aslw_archive_tmp (server_id,rule_id,level,timestamp,location_id,src_ip,dst_ip,src_port,dst_port,alertid,user,full_log,is_hidden,tld) VALUES (NEW.server_id,NEW.rule_id,NEW.level,NEW.timestamp,NEW.location_id,NEW.src_ip,NEW.dst_ip,NEW.src_port,NEW.dst_port,NEW.alertid,NEW.user,NEW.full_log,NEW.is_hidden,NEW.tld);
	END;@@
CREATE TRIGGER after_category_insert AFTER INSERT ON category FOR EACH ROW BEGIN REPLACE INTO aslw_mtimes (table_name,mtime) VALUES ('category',NOW()); END;@@
CREATE TRIGGER after_signature_insert AFTER INSERT ON signature FOR EACH ROW BEGIN REPLACE INTO aslw_mtimes (table_name,mtime) VALUES ('signature',NOW()); END;@@
CREATE TRIGGER after_signature_category_mapping_insert AFTER INSERT ON signature_category_mapping FOR EACH ROW BEGIN REPLACE INTO aslw_mtimes (table_name,mtime) VALUES ('signature_category_mapping',NOW()); END;@@
CREATE TRIGGER after_pgui_waf_cat_insert AFTER INSERT ON pgui_waf_cat FOR EACH ROW BEGIN REPLACE INTO aslw_mtimes (table_name,mtime) VALUES ('pgui_waf_cat',NOW()); END;@@
CREATE TRIGGER after_pgui_waf_cat_rule_map_insert AFTER INSERT ON pgui_waf_cat_rule_map FOR EACH ROW BEGIN REPLACE INTO aslw_mtimes (table_name,mtime) VALUES ('pgui_waf_cat_rule_map',NOW()); END;@@
CREATE TRIGGER after_pgui_waf_rules_insert AFTER INSERT ON pgui_waf_rules FOR EACH ROW BEGIN REPLACE INTO aslw_mtimes (table_name,mtime) VALUES ('pgui_waf_rules',NOW()); END;@@
DELIMITER ;
